
-- gives book a grab
-- similar to bfdia 5b i think

freeslot("MT_BOOK_HOLDBOX", "MT_BOOK_LAZYMOMENT", "SPR_HOLD", "SPR_HOWA", "SPR_HOFA", "SPR_HODO")

mobjinfo[MT_BOOK_HOLDBOX] = {
	doomednum = -1,
	spawnhealth = 1,
	spawnstate = S_INVISIBLE,
	deathstate = S_NULL,
	xdeathstate = S_NULL,
	deathsound = sfx_null,
	radius = 64*FU,
	height = 64*FU,
	flags = MF_NOCLIPHEIGHT|MF_NOGRAVITY
}

mobjinfo[MT_BOOK_LAZYMOMENT] = {
	doomednum = -1,
	spawnhealth = 1,
	spawnstate = S_INVISIBLE,
	deathstate = S_NULL,
	xdeathstate = S_NULL,
	deathsound = sfx_null,
	radius = 64*FU,
	height = 64*FU,
	flags = MF_NOCLIPHEIGHT|MF_NOGRAVITY
}

local function initializeVars(p)
	p.bookholding = false
	p.bookholdmo = nil
	p.bookc1held = 0
	p.bookc2held = 0
	if p.bot == 0
		p.bookholdbox = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_BOOK_HOLDBOX)
		p.bookholdbox.target = p.mo
	end
end

freeslot("SPR2_HOLD", "S_BOOK_HOLD", "SPR2_HOWA", "S_BOOK_HOLDWALK", "SPR2_HOFA", "S_BOOK_HOLDJUMP", "SPR2_HODO", "S_BOOK_HOLDFALL")

states[S_BOOK_HOLD] = {
	sprite = SPR_PLAY,
	frame = SPR2_HOLD,
	tics = -1,
	nextstate = S_BOOK_HOLD
}

states[S_BOOK_HOLDWALK] = {
	sprite = SPR_PLAY,
	frame = SPR2_HOWA|FF_ANIMATE,
	tics = -1,
	nextstate = S_BOOK_HOLDWALK,
	var1 = N,
	var2 = 2
}

states[S_BOOK_HOLDJUMP] = {
	sprite = SPR_PLAY,
	frame = SPR2_HOFA,
	tics = -1,
	nextstate = S_BOOK_HOLDJUMP
}

states[S_BOOK_HOLDFALL] = {
	sprite = SPR_PLAY,
	frame = SPR2_HODO,
	tics = -1,
	nextstate = S_BOOK_HOLDFALL
}

addHook("PlayerSpawn", initializeVars)

local function canGrab(p)
	if P_PlayerInPain(p)
	or p.playerstate == PST_DEAD
		return false
	end
	return true
end

local function shouldHurt(pmo, pmo2)
	local p = pmo.player
	local p2 = pmo2.player
	
	local ff = CV_FindVar("friendlyfire").value
	
	--if (G_CoopGametype() and ff == 1)
	if (G_RingSlingerGametype() and not G_TagGametype() and not G_GametypeHasTeams())
	or G_CompetitionGametype()
	or (G_GametypeHasTeams() and p2.ctfteam ~= p.ctfteam)
	or (G_TagGametype() and (p2.pflags & PF_TAGIT))
	or ff == 1
		return true
	end

	return false
end

/*local function collide(pmo, mo)
	if not ((mo.flags & MF_ENEMY) or (mo.flags & MF_SCENERY) or (mo.flags & MF_MONITOR) or mo.type == MT_PLAYER or mo.type == MT_BOOK_CORPSE)
	or pmo == mo
	or pmo.player.bookholdmo
	or not canGrab(pmo.player)
	or (pmo.player.pflags & PF_TAGIT) return end
	
	if pmo.z > mo.z+mo.height
	or mo.z > pmo.z+pmo.height return end
	
	local p = pmo.player
	
	if p.bookc1held == 1
	and not p.bookholding
		p.bookholdmo = mo
		p.bookholding = true
		mo.bookplyr = pmo
		mo.bookoldflags = {
			[1] = mo.flags,
			[2] = mo.flags2,
			[3] = mo.eflags
		}
		mo.flags = MF_NOTHINK|MF_NOCLIP|MF_NOCLIPHEIGHT
		p.bookc1held = 2
		print("hi")
	end
	print("hello")
end*/

local function skinCarry(s)
	if s == "book"
	or s == "match"
		return true
	end
	return false
end

local function throwCarry(p)
	local enmy = p.bookholdmo
	p.bookholding = false
	if (enmy.player and enmy.player.valid)
		enmy.angle = enmy.player.drawangle
	end
	if p.speed < 16*FU
		P_InstaThrust(enmy, enmy.angle, 16*FU)
	else
		P_InstaThrust(enmy, enmy.angle, 16*FU+FixedDiv(p.speed, FixedDiv(15, 10)))
	end
	P_SetObjectMomZ(enmy, 7*FU)
end

addHook("ThinkFrame", function()
	for p in players.iterate do
		if not (p.mo and p.mo.valid)
		or not skinCarry(p.mo.skin)
			if p.bookholding
			and p.bookholdmo
				throwCarry(p)
			end
			continue
		end
		
		if p.bookholding == nil
			initializeVars(p)
		end
		
		if p.playerstate == PST_LIVE
		and not (p.bookholdbox and p.bookholdbox.valid)
		and p.bot == 0
			p.bookholdbox = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_BOOK_HOLDBOX)
			p.bookholdbox.target = p.mo
		end
		
		if (p.cmd.buttons & BT_CUSTOM1)
			p.bookc1held = $+1
		else
			p.bookc1held = 0
		end
		
		if (p.cmd.buttons & BT_CUSTOM2)
			p.bookc2held = $+1
		else
			p.bookc2held = 0
		end
		
		local thing = FixedMul(p.mo.radius, FixedDiv(35, 10))
		
		if p.bookholding
			if p.bookholdmo
				local enmy = p.bookholdmo
				if (enmy.player and enmy.player.valid)
					enmy.player.drawangle = p.drawangle
					enmy.state = S_PLAY_PAIN
					if not shouldHurt(enmy, p.mo)
					and (enmy.player.cmd.buttons & BT_JUMP)
						enmy.flags = enmy.bookoldflags[1]
						enmy.flags2 = enmy.bookoldflags[2]
						enmy.eflags = enmy.bookoldflags[3]
						if (p.mo.eflags & MFE_VERTICALFLIP)
							enmy.eflags = $1|MFE_VERTICALFLIP
						else
							enmy.eflags = $ & ~MFE_VERTICALFLIP
						end
						enmy.player.pflags = $ & ~PF_JUMPED
						P_DoJump(enmy.player, true)
						enmy.momx = p.mo.momx
						enmy.momy = p.mo.momy
						enmy.momz = $+p.mo.momz
						p.bookholdmo = nil
						p.bookholding = false
						return
					end
				else
					enmy.angle = p.drawangle
				end
				
				if p.powers[pw_carry] == CR_ROPEHANG
					p.powers[pw_carry] = CR_NONE
					P_SetObjectMomZ(p.mo, -5*FU)
					P_InstaThrust(p.mo, R_PointToAngle2(0, 0, p.mo.momx, p.mo.momy), -p.speed)
				end
				
				local panimtable = {
					[PA_IDLE] = S_BOOK_HOLD,
					[PA_WALK] = S_BOOK_HOLDWALK,
					[PA_RUN] = S_BOOK_HOLDWALK,
					[PA_DASH] = S_BOOK_HOLDWALK,
					[PA_JUMP] = S_BOOK_HOLDJUMP,
					[PA_SPRING] = S_BOOK_HOLDJUMP,
					[PA_FALL] = S_BOOK_HOLDFALL
				}
				if p.mo.skin == "match"
					panimtable[PA_FALL] = S_BOOK_HOLDJUMP
				end
				
				if p.panim ~= PA_ETC
					p.bookpanim = p.panim
				else
					p.bookpanim = PA_IDLE
				end
				
				if panimtable[p.panim]
				and p.mo.state ~= panimtable[p.panim]
					p.mo.state = panimtable[p.panim]
					p.panim = p.bookpanim
				elseif not panimtable[p.panim]
					local state = S_BOOK_HOLD
					if P_IsObjectOnGround(p.mo)
						if p.speed > FU
							state = S_BOOK_HOLDWALK
						end
					else
						state = S_BOOK_HOLDJUMP
					end
					p.mo.state = state
					p.panim = p.bookpanim
				end
				
				local x = cos(p.drawangle)
				local y = sin(p.drawangle)
				if enmy.info.book3dbox
					P_MoveOrigin(enmy, p.mo.x+FixedMul(enmy.radius, x), p.mo.y+FixedMul(enmy.radius, y), p.mo.z+p.mo.height/2)
				else
					P_MoveOrigin(enmy, p.mo.x+FixedMul(p.mo.radius, x), p.mo.y+FixedMul(p.mo.radius, y), p.mo.z+p.mo.height/2)
				end
				enmy.eflags = p.mo.eflags
				
				if not P_IsObjectOnGround(p.mo)
				and not (p.mo.eflags & MFE_GOOWATER)
					P_SetObjectMomZ(p.mo, -abs(FixedDiv(FixedDiv(enmy.radius+enmy.height, 112*FU), FU+FU/2)), true)
				end
				if p.bookc1held == 1
					throwCarry(p)
				elseif p.bookc2held == 1
					p.bookholding = false
					P_SetObjectMomZ(enmy, FU)
				end
				
				if not canGrab(p)
					p.bookholding = false
					P_InstaThrust(enmy, p.drawangle, 5*FU)
				end
			else
				p.bookholding = false
			end
		elseif p.bookholdmo
			local enmy = p.bookholdmo
			enmy.bookthrown = true
			enmy.flags = 0
			if enmy.info.book3dbox
				enmy.flags = $1|MF_SOLID
			end
			if (enmy.player and enmy.player.valid)
			and not shouldHurt(p.mo, enmy)
			and enmy.player.bot == 0
				local p2 = enmy.player
				p2.pflags = $1|PF_SPINNING
				enmy.state = S_PLAY_ROLL
			end
			local boxthing = P_SpawnMobj(enmy.x, enmy.y, enmy.z, MT_BOOK_LAZYMOMENT)
			boxthing.target = enmy
			p.bookholdmo = nil
		elseif p.mo.state >= S_BOOK_HOLD
		and p.mo.state <= S_BOOK_HOLDFALL
			p.mo.state = S_PLAY_STND
		end
	end
end)

addHook("MobjDeath", function(pmo)
	if not skinCarry(pmo.skin) return end
	
	local p = pmo.player
	
	if (p.bookholdbox and p.bookholdbox.valid)
		P_RemoveMobj(p.bookholdbox)
		p.bookholdbox = nil
	end
end, MT_PLAYER)

addHook("MobjThinker", function(mo)
	if not (mo.target and mo.target.valid) P_RemoveMobj(mo) return end
	
	local pmo = mo.target
	local p = pmo.player
	
	if not skinCarry(pmo.skin)
		if p.bookholdbox
			p.bookholdbox = nil
		end
		P_RemoveMobj(mo)
		return
	end
	
	P_SetOrigin(mo, pmo.x, pmo.y, pmo.z)
	mo.angle = pmo.angle
	
	if leveltime%2 == 0
		mo.height = FU
	else
		mo.height = pmo.height
	end
	mo.radius = FixedMul(pmo.radius, FixedDiv(35, 10))
end, MT_BOOK_HOLDBOX)

local function collide(box, mo)
	if not ((mo.flags & MF_ENEMY) or (mo.flags & MF_SCENERY) or (mo.flags & MF_MONITOR) or mo.type == MT_PLAYER or mo.info.bookgrabbable)
	or mo == box.target
	or box.target.player.bookholdmo
	or not canGrab(box.target.player)
	or (box.target.player.pflags & PF_TAGIT) return end
	
	if box.z > mo.z+mo.height
	or mo.z > box.z+box.height return end
	
	local pmo = box.target
	local p = pmo.player
	
	if p.bookc1held == 1
	and not p.bookholding
		p.bookholdmo = mo
		p.bookholding = true
		mo.bookplyr = pmo
		mo.bookoldflags = {
			[1] = mo.flags,
			[2] = mo.flags2,
			[3] = mo.eflags
		}
		mo.flags = MF_NOTHINK|MF_NOCLIP|MF_NOCLIPHEIGHT
		/*if not (mo.player and mo.player.valid)
			mo.flags = MF_NOTHINK|MF_NOCLIP|MF_NOCLIPHEIGHT
		else
			mo.flags = $1|MF_NOCLIP|MF_NOCLIPHEIGHT
		end*/
		p.bookc1held = 2
	end
end

addHook("MobjCollide", collide, MT_BOOK_HOLDBOX)
addHook("MobjMoveCollide", collide, MT_BOOK_HOLDBOX)

local function collidethesecond(enmy, mo)
	if not enmy.bookthrown
	or not (mo.flags & MF_SHOOTABLE)
	or mo == enmy.bookplyr return end
	
	if enmy.z > mo.z+mo.height
	or mo.z > enmy.z+enmy.height return end
	
	if ((enmy.player and enmy.player.valid) and not (mo.player and mo.player.valid))
		enmy.flags = enmy.bookoldflags[1]
		return
	end
	
	if (enmy.player and enmy.player.valid)
	and not shouldHurt(enmy, mo) return end
	
	if (enmy.player and enmy.player.valid)
		P_DamageMobj(mo, enmy)
		enmy.flags = enmy.bookoldflags[1]
		P_DamageMobj(enmy, mo)
	else
		P_DamageMobj(mo, enmy, enmy.bookplyr)
		enmy.flags = enmy.bookoldflags[1]
		P_DamageMobj(enmy, mo, enmy.bookplyr)
	end
end

addHook("MobjCollide", collidethesecond)
addHook("MobjMoveCollide", collidethesecond)

addHook("MobjDeath", function(mo)
	if not mo.bookthrown
	or not mo.bookplyr return end
	
	mo.bookplyr.player.bookholdmo = nil
end)

addHook("MobjThinker", function(mo)
	local enmy = mo.target
	if (enmy and enmy.valid)
		local pmo = enmy.bookplyr
		local p = pmo.player
		P_SetOrigin(mo, enmy.x, enmy.y, enmy.z)
		if abs(FixedDiv(FixedDiv(enmy.radius+enmy.height, 112*FU), FU+FU/2)) >= FU
			P_SetObjectMomZ(enmy, -abs(FixedDiv(FixedDiv(enmy.radius+enmy.height, 112*FU), FU+FU/2)), true)
		end
		if P_IsObjectOnGround(enmy)
			enmy.flags = enmy.bookoldflags[1]
			enmy.flags2 = enmy.bookoldflags[2]
			enmy.eflags = enmy.bookoldflags[3]
			if (pmo.eflags & MFE_VERTICALFLIP)
				enmy.eflags = $1|MFE_VERTICALFLIP
			else
				enmy.eflags = $ & ~MFE_VERTICALFLIP
			end
			enmy.bookthrown = false
			S_StartSound(enmy, sfx_s3k4c)
			for i = 1, 16 do
				local dust = P_SpawnMobj(enmy.x, enmy.y, enmy.z, MT_SPINDUST)
				dust.angle = i*ANGLE_22h
				P_InstaThrust(dust, dust.angle, 16*FU)
				dust.scalespeed = FU/16
				dust.destscale = 0
			end
			P_RemoveMobj(mo)
			return
		end
	else
		P_RemoveMobj(mo)
		return
	end
end, MT_BOOK_LAZYMOMENT)